// Copyright (c) 2005  INRIA Sophia-Antipolis (France).
// All rights reserved.
//
// This file is part of cgal-python; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; version 2.1 of the License.
// See the file LICENSE.LGPL distributed with cgal-python.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $Id: Geometric_Optimisation_module.cpp 182 2007-11-08 15:17:32Z spion $
// $URL: svn+ssh://scm.gforge.inria.fr/svn/cgal-python/trunk/cgal-python/bindings/Geometric_Optimisation/Geometric_Optimisation_module.cpp $
//
// Author(s)     : Naceur Meskini
//=========================================================================

#include <CGAL/basic.h>
#include <include/cgal_exception.h>
#include <boost/python.hpp>
#include <boost/cstdint.hpp>

extern void export_Min_circle_2();
extern void export_Min_ellipse_2();
extern void export_Min_sphere_d();
extern void export_Min_annulus_d();

using namespace boost::python;

BOOST_PYTHON_MODULE(Geometric_Optimisation)
{
	CGAL::set_error_handler(python_cgal_error_handler);

	export_Min_circle_2();
	export_Min_ellipse_2();
	export_Min_sphere_d();
	export_Min_annulus_d();
}
