# A common part of the makefiles

include $(CGAL_MAKEFILE)

# For linking shared libraries/plugins, Darwin (Mac OS X) needs "-dynamiclib",
# while Linux needs "-shared".
# Additionnally, Darwin explicitely needs -lpython, while Linux finds it as a
# dependency of -lboost_python (it seems), and Linux does not like -lpython,
# as it would prefer, e.g. -lpython2.4 on FC5.
LDOPT=`(uname | grep Darwin > /dev/null) && echo "-dynamiclib -lpython" || echo "-shared"`

CGAL_PYTHON_LDFLAGS=$(LDOPT) -lboost_python $(LDFLAGS) $(CGAL_LDFLAGS)


CGAL_PYTHON_CXXFLAGS=-fPIC -DCGAL_DONT_USE_LAZY_KERNEL $(CXXFLAGS) $(CPPFLAGS) $(CGAL_CXXFLAGS) -I../.. -O2
