#!/usr/bin/python
print "		======================================================"
print "				testing Alpha_shape_2"
print "		======================================================\n"

from sys import *
path.append("../../cgal_package")

from CGAL.Alpha_shapes_2 import *
from CGAL.Triangulations_2 import Delaunay_triangulation_2

from CGAL.Kernel import *
from random import *

def Point_2_str(self):
    return "Point_2"+str((self.x(), self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str

def show_alpha_values(AS):
	print "Alpha spectrum"
	for alpha_value in AS.alpha:
		print alpha_value

def read_points(file):
	result=[]
	f = open(file,'r+')
	for line in f:
		l = line.rstrip().split()
		for i in l:
			result.append(float(i))
	f.close()
	return result
			
def test_Alpha_shapes_2():	
	L =[]
	verbose = True
	l = read_points("data/fin")
	nb = int(l[0])
	list_of_points = []
	for i in range(nb):
		list_of_points.append(Point_2(l[2*i+1],l[2*i+2]))
		
	a = Alpha_shape_2()
	a.make_alpha_shape(list_of_points)
	a.set_mode(Alpha_shape_2.Mode.REGULARIZED)
	a.set_alpha(1000)
	alpha_shape_edges = []
	alpha_shape_vertices = []
	for it in a.alpha_shape_edges:
		alpha_shape_edges.append(a.segment(it))
	for it in a.alpha_shape_vertices:
		alpha_shape_vertices.append(it)
	
	print "alpha_shape_edges"	
	print len(alpha_shape_edges)
	print "alpha_shape_vertices"	
	print len(alpha_shape_vertices)
	print "Optimal alpha: " 
	print a.find_optimal_alpha(2).next()
	
# 	show_alpha_values(a)


if __name__ == '__main__':
	test_Alpha_shapes_2()




