#!/usr/bin/python

print "======================================================"
print "============  testing Delaunay_mesher_2 =============="
print "======================================================\n"

from sys import *
path.append("../../cgal_package")

from CGAL import *

def Point_2_str(self):
    return "Point_2"+str((self.x(), self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str


cdt = Constrained_Delaunay_triangulation_2()
va = cdt.insert(Point_2(-4,0));
vb = cdt.insert(Point_2(0,-1));
vc = cdt.insert(Point_2(4,0));
vd = cdt.insert(Point_2(0,1));
cdt.insert(Point_2(2, 0.6));

cdt.insert_constraint(va, vb);
cdt.insert_constraint(vb, vc);
cdt.insert_constraint(vc, vd);
cdt.insert_constraint(vd, va);

print "Number of vertices: ", cdt.number_of_vertices()

print "Meshing with new criterias..."
#   // 0.125 is the default shape bound. It corresponds to abound 20.6 degree.
#   // 0.5 is the upper bound on the length of the longuest edge.
#   // See reference manual for Delaunay_mesh_size_traits_2<K>.
mesher = Delaunay_mesher_2(cdt);
mesher.refine_mesh();
print "Number of vertices: ", cdt.number_of_vertices()

mesher.set_criteria(0.25, 0.5);
mesher.refine_mesh();
print "Number of vertices: ", cdt.number_of_vertices()


print "======================================================"
print "==========        Mesh_with_seeds      ==============="
print "======================================================"

cdt = Constrained_Delaunay_triangulation_2()

va = cdt.insert(Point_2(2,0));
vb = cdt.insert(Point_2(0,2));
vc = cdt.insert(Point_2(-2,0));
vd = cdt.insert(Point_2(0,-2));

cdt.insert_constraint(va, vb);
cdt.insert_constraint(vb, vc);
cdt.insert_constraint(vc, vd);
cdt.insert_constraint(vd, va);

va = cdt.insert(Point_2(3,3));
vb = cdt.insert(Point_2(-3,3));
vc = cdt.insert(Point_2(-3,-3));
vd = cdt.insert(Point_2(3,-3));

cdt.insert_constraint(va, vb);
cdt.insert_constraint(vb, vc);
cdt.insert_constraint(vc, vd);
cdt.insert_constraint(vd, va);

print "Number of vertices: " , cdt.number_of_vertices() 

print "Meshing the domain..." 

mesher = Delaunay_mesher_2(cdt);
mesher.set_seeds([Point_2(0, 0)])
mesher.refine_mesh();

print "Number of vertices: " , cdt.number_of_vertices() 

s = mesher.seeds.next() # visiting all seeds.
print s
