#!/usr/bin/python
print "======================================================"
print "============     testing Min_circle_2   =============="
print "======================================================\n"

# import pdb # python debugging

from sys import *
path.append("../../cgal_package")

from CGAL.Geometric_Optimisation import *
from CGAL.Kernel import *
from random import *

def Point_2_str(self):
    return "Point_2" +str((self.x() , self.y()))
	
# now we turn it into a member function
Point_2.__str__ = Point_2_str

def test_Min_circle_2():
# generate `n' points at random
	random_points = []
	print " random points from [0,128)^2:" 
	for i in range(20):
		p = Point_2(random()*128,random()*128)
		random_points.append(p )
		print p

	print "default constructor...";

	mc = Min_circle_2()  ;
	is_valid = mc.is_valid();
	is_empty = mc.is_empty();
	assert( is_valid);
	assert( is_empty);


	print "one point constructor...";

	mc = Min_circle_2( random_points[ 0]);
	is_valid      = mc.is_valid();
	is_degenerate = mc.is_degenerate();
	assert( is_valid);
	assert( is_degenerate);


	print "two points constructor...";

	mc = Min_circle_2( random_points[ 1],
					random_points[ 2]);
	is_valid = mc.is_valid();
	assert( is_valid);
	assert( mc.number_of_points() == 2);


	print "three points constructor...";

	mc = Min_circle_2( random_points[ 3],random_points[ 4],random_points[ 5]);
	is_valid = mc.is_valid();
	assert( is_valid);
	assert( mc.number_of_points() == 3);


	print "list constructor...";
	
	mc2 = Min_circle_2();
	for p in range(9):
		mc2.insert(random_points[p])
	mc = Min_circle_2();mc.insert(random_points[:9])
	is_valid  = mc2.is_valid();
	is_valid2 = mc.is_valid();
	assert( is_valid);
	assert( is_valid2);
	assert( mc.number_of_points() == 9);
	assert( mc2.number_of_points() == 9);
	assert( mc2.circle() == mc.circle());
	print "support points access...";
	it = mc.support_points
	for i in range(mc.number_of_support_points()):
		support_point = mc.support_point(i)
		assert( support_point == it.next())

	print "in-circle predicates..."

	for i in range(9):
		p = random_points[i];
		bounded_side          = mc.bounded_side( p)
		has_on_bounded_side   = mc.has_on_bounded_side( p)
		has_on_boundary       = mc.has_on_boundary( p)
		has_on_unbounded_side = mc.has_on_unbounded_side( p)
		assert( bounded_side != Bounded_side.ON_UNBOUNDED_SIDE)
		assert( has_on_bounded_side or has_on_boundary)
		assert( has_on_unbounded_side == False )



if __name__ == '__main__':
	test_Min_circle_2()