#!/usr/bin/python
print "======================================================"
print "============     testing Min_ellipse_2   =============="
print "======================================================\n"

from sys import *
path.append("../../cgal_package")

from CGAL.Geometric_Optimisation import *
from CGAL.Kernel import *
from random import *

def Point_2_str(self):
    return "Point_2" +str((self.x() , self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str

def test_Min_ellipse_2():
	verbose = True
	# generate `n' points at random
	random_points = []
	
	print  " random points from [0,128)^2:"  
	
	for i in range(20):
		random_points.append(Point_2(random()*128,random()*128) )

	print  "default constructor..."
	
	me =  Min_ellipse_2()  
	is_valid = me.is_valid( verbose)
	is_empty = me.is_empty()
	assert( is_valid)
	assert( is_empty)
	
	
	print  "one point constructor..."
	
	me = Min_ellipse_2( random_points[ 0])
	is_valid      = me.is_valid( verbose)
	is_degenerate = me.is_degenerate()
	assert( is_valid)
	assert( is_degenerate)
	
	
	print  "two points constructor..."
	
	me = Min_ellipse_2( random_points[ 1],random_points[ 2])
	is_valid      = me.is_valid( verbose)
	is_degenerate = me.is_degenerate()
	assert( is_valid)
	assert( is_degenerate)
	
	
	print  "three points constructor..."
	
	me = Min_ellipse_2( random_points[3],random_points[ 4],random_points[ 5])
	is_valid = me.is_valid( verbose)
	num_pts  = me.number_of_points()
	assert( is_valid)
	assert( num_pts == 3)
	
	
	print  "four points constructor..."
	
	me = Min_ellipse_2( random_points[ 6],random_points[ 7],random_points[ 8],random_points[ 9])
	is_valid = me.is_valid( verbose)
	num_pts  = me.number_of_points()
	assert( is_valid)
	assert( num_pts == 4)
	
	print  "five points constructor..."
	
	me = Min_ellipse_2( random_points[ 10],random_points[ 11],random_points[ 12],random_points[ 13],random_points[ 14])
	is_valid = me.is_valid( verbose)
	num_pts  = me.number_of_points()
	assert( is_valid)
	assert( num_pts == 5)
	
	
if __name__ == '__main__':
	test_Min_ellipse_2()