#!/usr/bin/python
print "======================================================"
print "============     testing Min_sphere_2   =============="
print "======================================================\n"

import pdb # python debugging

from sys import *
path.append("../../cgal_package")

from CGAL.Geometric_Optimisation import *
from CGAL.Kernel import *
from random import *

def Point_2_str(self):
    return "Point_2" +str((self.x(), self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str

def Point_3_str(self):
    return "Point_3"+str((self.x() , self.y(), self.z()))
# now we turn it into a member function
Point_3.__str__ = Point_3_str

def test_Min_sphere_d():
# generate `nbpts' points  randomly
	random_2d_points = []
	random_3d_points = []
	print " random points from [0,128):"
	print "===============================\n" 
	nbpts = 20
	for i in range(nbpts):
		p,q = Point_2(random()*128,random()*128),Point_3(random()*128,random()*128,random()*128)
		random_2d_points.append(p );
		random_3d_points.append(q)

	for p in random_2d_points:
		print p
	print "===============================\n"
	for q in random_3d_points:
		print q	
	print "===============================\n"
	
	print "default constructor...";

	ms = Min_sphere_2()  ;
	is_valid = ms.is_valid();
	is_empty = ms.is_empty();
	assert( is_valid);
	assert( is_empty);
	#===================
	ms = Min_sphere_3()  ;
	is_valid = ms.is_valid();
	is_empty = ms.is_empty();
	assert( is_valid);
	assert( is_empty);
	
	print "inserting points...";
	
	ms2 = Min_sphere_2();
	for p in range(nbpts):
		ms2.insert(random_2d_points[p])
	ms3 = Min_sphere_2();ms3.insert(random_2d_points)
	is_valid  = ms2.is_valid();
	is_valid2  = ms3.is_valid();
	
	assert( is_valid);
	assert( is_valid2);
	assert( ms2 .number_of_points() == nbpts);
	assert( ms3.number_of_points() == nbpts);
	assert( ms2.center() == ms3.center());
	print "support points access...";
	it = ms2.support_points
	for p in it:
		print p

	print "in-circle predicates...";

	for i in range(2):
		p = random_2d_points[i];
		print ms2.bounded_side( p);
		print ms2.has_on_bounded_side( p);
		print ms2.has_on_boundary( p);
		print ms2.has_on_unbounded_side( p);
		
	# ========= 3d case =================
	
	ms2 = Min_sphere_3()
	for p in random_3d_points:
		ms2.insert(p)
	
	ms3 = Min_sphere_3(); ms3.insert(random_3d_points)
	is_valid  = ms2.is_valid()
	is_valid2  = ms3.is_valid()
	
	assert( is_valid);
	assert( is_valid2);
	
	assert( ms3.number_of_points() == nbpts)
	assert( ms2 .number_of_points() == nbpts)
	assert( ms2.center() == ms3.center())
	print "support points access..."
	it = ms2.support_points
	for p in it:
		print p

	print "in-circle predicates..."

	for i in range(2):
		p = random_3d_points[i];
		print ms2.bounded_side( p);
		print ms2.has_on_bounded_side( p);
		print ms2.has_on_boundary( p);
		print ms2.has_on_unbounded_side( p);


if __name__ == '__main__':
	test_Min_sphere_d()