#!/usr/bin/python
print "		======================================================"
print "				testing Constrained_delaunay_triangulation_2"
print "		======================================================\n"

from sys import *
path.append("../../cgal_package")

from CGAL.Triangulations_2 import *
from CGAL.Kernel import *
from random import *

def Point_2_str(self):
    return "Point_2"+str((self.x(), self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str


lpt = [
	Point_2(0,0), Point_2(1,0), Point_2(2,0), Point_2(3,0),Point_2(4,0),
	Point_2(4,1), Point_2(3,1), Point_2(2,1), Point_2(1,1),Point_2(0,1),
	Point_2(0,2), Point_2(1,2), Point_2(2,2), Point_2(3,2),Point_2(4,2),
	Point_2(4,3), Point_2(3,3), Point_2(2,3), Point_2(1,3),Point_2(0,3)
]
T2 = Constrained_Delaunay_triangulation_2()
for m in range(19): 
	T2.insert_constraint(lpt[m],lpt[m+1]) 


assert( T2.dimension() == 2 ) 
assert( T2.number_of_vertices() == 20) 
assert( T2.is_valid() ) 

# # test get_conflicts

conflicts = T2.get_conflicts(Point_2(1,1,2)) 
hole_bd = T2.get_boundary_of_conflicts(Point_2(1,1,2)) 

assert(len(hole_bd) == len(conflicts) + 2) 

conflicts = T2.get_conflicts(Point_2(0,1,2)) 
hole_bd = T2.get_boundary_of_conflicts(Point_2(0,1,2)) 
assert(len(hole_bd) == len(conflicts) + 2) 


conflicts = T2.get_conflicts(Point_2(0,0,1)) 
assert(len(conflicts) == 0) 
conflicts = T2.get_conflicts(Point_2(-1,-1,1)) 



#test remove_constrained_edge
print "test_remove_constrained_edge with output"  
T3 =  Constrained_Delaunay_triangulation_2()
v0 = T3.insert(Point_2(0,0)) 
T3.insert(Point_2(1,1)) 
T3.insert(Point_2(2,1.1)) 
T3.insert(Point_2(3,1)) 
v4=T3.insert(Point_2(4,0)) 
T3.insert(Point_2(2, -2)) 
T3.insert_constraint(v0,v4) 


e=Edge()
check = T3.is_edge(v0,v4,e)
assert(check) 
print e.face().vertex(e.vertex()).point()
print "done"
