#!/usr/bin/python
print "		======================================================"
print "				testing Constrained_triangulation_2"
print "		======================================================\n"

from sys import *
path.append("../../cgal_package")

from CGAL.Triangulations_2 import *
from CGAL.Kernel import *
from random import *

def Point_2_str(self):
    return "Point_2"+str((self.x(), self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str



# Constructors
print  "constructors    "   
l =[]

# Empty Constrained_trianguulation (0-dimensional)
print  "    0-Dim "  
T0_1 = Constrained_triangulation_2()  
assert( T0_1.dimension() == -1 ) 
assert( T0_1.number_of_vertices() == 0 ) 
assert( T0_1.is_valid() ) 

l.append(Constraint(Point_2(0,0),Point_2(0,0))) 
T0_2 = Constrained_triangulation_2()
T0_2.push_back(l[0])
assert( T0_2.dimension() == 0 ) 
assert( T0_2.number_of_vertices() == 1 ) 
assert( T0_2.is_valid() ) 
l =[]

# Build Constrained_trianguulations, 1-dimensional
print  "    1-Dim " 
for m in range(4):
	l.append(Constraint(Point_2(3*m, 2*m),Point_2(3*m,2*m) )) 
T1_1 = Constrained_triangulation_2()
for c in l:
	T1_1.push_back(c)  
assert( T1_1.dimension() == 1 ) 
assert( T1_1.number_of_vertices() == 4 ) 
assert( T1_1.is_valid() ) 

l=[] 
for m in range(4):
	l.append(Constraint(Point_2(3*m, 2*m),Point_2(3*(m+1),2*(m+1)) )) 
T1_2 = Constrained_triangulation_2()

for c in l:
	T1_2.push_back(c)
	   
assert( T1_2.dimension() == 1 ) 
assert( T1_2.number_of_vertices() == 5) 
assert( T1_2.is_valid() ) 
l=[] 

# Build Constrained_trianguulations, 2-dimensional
print  "    2-Dim "  
lp= [Point_2(0,0),Point_2(1,0),Point_2(0,1),Point_2(-1,0),Point_2(0,-1)] 
for m in range(4):
	l.append(Constraint(lp[0],lp[m+1]))
	 
T2_1 = Constrained_triangulation_2()

for c in l:
	T2_1.push_back(c)
	  
assert( T2_1.dimension() == 2 ) 
assert( T2_1.number_of_vertices() == 5) 
assert( T2_1.is_valid() ) 

l = [] 

lpt= [
Point_2(0,0), Point_2(1,0), Point_2(2,0), Point_2(3,0),Point_2(4,0),
Point_2(4,1), Point_2(3,1), Point_2(2,1), Point_2(1,1),Point_2(0,1),
Point_2(0,2), Point_2(1,2), Point_2(2,2), Point_2(3,2),Point_2(4,2),
Point_2(4,3), Point_2(3,3), Point_2(2,3), Point_2(1,3),Point_2(0,3)
] 
for m in range(19): 
	l.append(Constraint(lpt[m],lpt[m+1]))
	 
T2_2 = Constrained_triangulation_2() 
for c in l:
	T2_2.push_back(c)
	
assert( T2_2.dimension() == 2 ) 
assert( T2_2.number_of_vertices() == 20) 
assert( T2_2.is_valid() ) 

# There are too many constraint here to make difference
# between constrained and Constrained Delaunay
T2_5 = Constrained_triangulation_2()
for p in lpt:
	T2_5.insert(p)
T2_5.insert( Point_2(1,0.5), Point_2(2.5, 3.5)) 
T2_5.is_valid() 


# test assignement operator
Taux = T2_2 
assert( Taux.dimension() == 2 ) 
assert( Taux.number_of_vertices() == 20) 
assert( Taux.is_valid() ) 

l=[]
# remove_constraint and remove _1 dim
print  "remove_constrained_edge and remove 1-dim"   

fh  =  T1_2.locate(Point_2(0,0),l); lt=l[0];li=l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX ) 
vha = fh.vertex(li)
l=[] 
fh  =  T1_2.locate(Point_2(3,2),l); lt=l[0];li=l[1];assert( lt == Constrained_triangulation_2.Locate_type.VERTEX ) 
vhb =  fh.vertex(li)
e = Edge() 
assert(T1_2.is_edge(vha,vhb, e))
assert(e.face().is_constrained(e.vertex())) 
T1_2.remove_constrained_edge(e.face(),e.vertex()) 
assert(T1_2.is_valid()) 
T1_2.insert(Point_2(0,0),Point_2(3,2)) 
l=[]
fh  =  T1_2.locate(Point_2(3,2),l); lt=l[0];li=l[1]; assert( lt == Constrained_triangulation_2.Locate_type.VERTEX ) 
vhb =  fh.vertex(li) 
assert(T1_2.are_there_incident_constraints(vhb)) 
T1_2.remove_incident_constraints(vhb) 
T1_2.remove(vhb) 
l=[]
fh  =  T1_2.locate(Point_2(6,4),l); lt=l[0];li=l[1];  assert( lt == Constrained_triangulation_2.Locate_type.VERTEX ) 
vha = fh.vertex(li) 

assert(T1_2.are_there_incident_constraints(vha)) 
edges = T1_2.incident_constraints(vha)
print len(edges) 
T1_2.remove_incident_constraints(vha) 
edges = T1_2.incident_constraints(vha)
print len(edges) 
T1_2.remove(vha) 
assert(T1_2.is_valid()) 


# remove_constraint and remove 2 dim
print  "remove_constrained_edge and remove 2-dim "   
m=2 
l=[]
fh = T2_2.locate(lpt[m],l); lt=l[0];li=l[1];  assert( lt == Constrained_triangulation_2.Locate_type.VERTEX ) 
vha = fh.vertex(li)
l=[] 
fh  =  T2_2.locate(lpt[m+1],l); lt=l[0];li=l[1];  assert( lt == Constrained_triangulation_2.Locate_type.VERTEX ) 
vhb =  fh.vertex(li) 
e=Edge()
check = T2_2.is_edge(vha,vhb,e) 
assert(check)
fh = e.face();ih = e.vertex() 
assert(fh.is_constrained(ih)) 
T2_2.remove_constrained_edge(fh,ih) 

T2_2.insert(lpt[m], lpt[m+1]) 
assert(T2_2.is_valid()) 
fh  =  T2_2.locate(lpt[m+1],l); lt=l[0];li=l[1]; assert( lt == Constrained_triangulation_2.Locate_type.VERTEX ) 
vhb =  fh.vertex(li)   
assert(T2_2.are_there_incident_constraints(vhb)) 
T2_2.remove_incident_constraints(vhb) 
T2_2.remove(vhb) 

l=[]
m=15 
fh  =  T2_2.locate(lpt[m],l); lt=l[0];li=l[1];  assert( lt == Constrained_triangulation_2.Locate_type.VERTEX ) 
vha = fh.vertex(li)
# 
assert(T2_2.are_there_incident_constraints(vha)) 
assert(T2_2.are_there_incident_constraints(vha))
 
edges = T2_2.incident_constraints(vha) 
print len(edges)
T2_2.remove_incident_constraints(vha) 
edges = T2_2.incident_constraints(vha) 
print len(edges)
T2_2.remove(vha) 
assert(T2_2.is_valid()) 

print "done"
