#!/usr/bin/python
print "		======================================================"
print "				testing Constrained_triangulation_plus_2"
print "		======================================================\n"

from sys import *
path.append("../../cgal_package")

from CGAL.Kernel import *
from CGAL.Triangulations_2 import Constrained_triangulation_plus_2 as ctp
from CGAL.Triangulations_2 import Constraint
from random import *

def Point_2_str(self):
    return "Point_2"+str((self.x(), self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str

pt = [
	Point_2(0,0), Point_2(0,4), 
	Point_2(1,0), Point_2(1,4), 
	Point_2(2,0), Point_2(2,4),
	Point_2(-1,1), Point_2(3,1),
	Point_2(-1,2), Point_2(3,2),
	Point_2(0.5,1), Point_2(2.5,1)
]

trp = ctp()

vh = {}
for i,p in enumerate(pt):
	vh[i] = trp.insert(p)

for j in range(11):
	trp.insert_constraint(vh[j],vh[j+1])

trp.insert_constraint(Point_2(4,4), Point_2(4,5))
trp.push_back(Point_2(4,6))
trp.push_back(Constraint(Point_2(4,3), Point_2(3,4)))

# // test access to the hierarchy
print  "test acces to the constriant hierarchy"  
vit = trp.vertices_in_constraint(vh[10],vh[11])
first_value = vit.next()
assert (first_value == vh[10] or first_value == vh[11] )
va = vit.next()
vb = vit.next()
assert(trp.number_of_enclosing_constraints(va,vb) == 2)
cit1 = trp.contexts(va,vb)

# for c in cit1:
# 	print c.number_of_vertices()
	
c = cit1.next()

for v in c.vertices:
	print v.point()
	

# //test remove_constraint
print  "test removal of constraint"  
trp.remove_constraint(vh[10],vh[11])
trp.remove_constraint(vh[6],vh[7])


print "done"
