#!/usr/bin/python
print "		======================================================"
print "				testing Delaunay_triangulation_2"
print "		======================================================\n"

from sys import *
path.append("../../cgal_package")

from CGAL.Triangulations_2 import *
from CGAL.Kernel import *
from random import *


def Point_2_str(self):
    return "Point_2"+str((self.x(), self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str


# Constructors
print "constructors(3)" 

# Build dummy delaunay triangulations, 1- and 2-dimensional
T1 = Delaunay_triangulation_2()
for m in range(20):
	T1.insert( Point_2(3*m, 2*m) )
assert( T1.is_valid() )

T2 = Delaunay_triangulation_2()

for m in range(20):
	for p in range(20):
		T2.insert(Point_2(m,p))
assert( T2.is_valid() )

T3 = Delaunay_triangulation_2()
# All these points are on a circle of radius 325
pt = [
	Point_2(36,323), Point_2(80,315), Point_2(91,-312),
	Point_2(125,300), Point_2(165,280), Point_2(195,-260), Point_2(204,253),
	Point_2(36,-323), Point_2(80,-315), Point_2(91,-312),
	Point_2(125,-300), Point_2(165,-280), Point_2(195,-260), Point_2(204,-253),
	Point_2(-36,-323), Point_2(-80,-315), Point_2(-91,-312),
	Point_2(-125,-300), Point_2(-165,-280), Point_2(-195,-260), Point_2(-204,-253),
	Point_2(-36,323), Point_2(-80,315), Point_2(-91,312),
	Point_2(-125,300), Point_2(-165,280), Point_2(-195,260), Point_2(-204,253)
	]
for p in pt:
	T3.insert( p )
assert( T3.is_valid() )

# test nearest_vertex

l = []
cible = T2.locate(Point_2(0,0,1),l);lt=l[0];i=l[1];
assert( lt == Triangulation_2.Locate_type.VERTEX)
vnn = T2.nearest_vertex(Point_2(1,1,3))
assert(vnn == cible.vertex(i))
vnn = T2.nearest_vertex(Point_2(0,1,3))
assert(vnn == cible.vertex(i))
vnn = T2.nearest_vertex(Point_2(0,0,1))
assert(vnn == cible.vertex(i))
vnn = T2.nearest_vertex(Point_2(-1,-1,2))
assert(vnn == cible.vertex(i))

# test get_conflicts and star_hole
print "get conflicts and star_hole" 

conflicts = T2.get_conflicts(Point_2(0,1,2))
hole_bd = T2.get_boundary_of_conflicts(Point_2(0,1,2))
assert(len(hole_bd) == len(conflicts) + 2)

conflicts = T2.get_conflicts(Point_2(0,0,1))
assert(len(conflicts) == 0)


# /********************/
# /***** Duality ******/

print "duality" 

for f in T2.faces:
	assert( T2.side_of_oriented_circle(f, T2.dual(f)) == Oriented_side.ON_POSITIVE_SIDE );
for f in T3.faces:
	assert( T3.side_of_oriented_circle(f, T3.dual(f)) == Oriented_side.ON_POSITIVE_SIDE );

for eit in T2.edges:
	o = T2.dual(eit)
	if o.__class__ == Segment_2:
		assert( T2.is_infinite(eit.face()) == False )
		assert( T2.is_infinite(eit.face().neighbor( eit.vertex() ) ) == False )
	elif o.__class__ == Line_2:
		assert( T2.dimension() == 1 )
	else:
		assert(o.__class__ == Ray_2)
		
for eit in T3.edges:
	o = T3.dual(eit)
	if o.__class__ == Segment_2:
		assert( T3.is_infinite(eit.face()) == False )
		assert( T3.is_infinite(eit.face().neighbor( eit.vertex() ) ) == False )
	elif o.__class__ == Line_2:
		assert( T3.dimension() == 1 )
	else:
		assert(o.__class__ == Ray_2)
		