#!/usr/bin/python
print "		======================================================"
print "				testing Regular_triangulation_2"
print "		======================================================\n"

from sys import *
path.append("../../cgal_package")

from CGAL.Triangulations_2 import *
from CGAL.Kernel import *
from random import *


def Point_2_str(self):
    return "Point_2"+str((self.x(), self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str


verbose = False
# 
#   # Build a few objects
#   # p1,p3,p2,p9,p8 aligned in this order
#   # p0,p5,p7 also
# 
p0 = Point_2(5,6,1)
p1 = Point_2(1,9,1)
p2 = Point_2(6,14,1)
p3 = Point_2(4,12,1)
p4 = Point_2(3,29,1)
p5 = Point_2(6,7,1)
p6 = Point_2(6,39,1)
p7 = Point_2(8,9,1)
p8 = Point_2(10,18,1)
p9 = Point_2(75625,155625,10000) # intersection of p2,p8 and p6,p7
p10 = Point_2(10,50,2)
p11 = Point_2(6,15,2) # midpoint p1,p0
p12 = Point_2(6,16,2) # slightly above, in face
p13 = Point_2(10,11,1)
p14 = Point_2(10,40,1)
p15 = Point_2(60,-10,1)

px=1; py=1
qx=-1; qy=2


wp0 = Weighted_point(p0,1)
wp1 = Weighted_point(p1,20)
wp2 = Weighted_point(p2,20)
wp3 = Weighted_point(p3,1) 
#wp3 = Weighted_point(p3,1)
wp4 = Weighted_point(p4,1)
wp5 = Weighted_point(p5,8)
wp6 = Weighted_point(p6,1)
wp7 = Weighted_point(p7,1)
wp8 = Weighted_point(p8,20)
wp9 = Weighted_point(p9,1) # intersection of p2,p8 and p6,p7
wp10 = Weighted_point(p10,2)
#wp11 = Weighted_point(p11,2) # midpoint p1,p0
wp12 = Weighted_point(p12,2) # slightly above, in face
#wp13 = Weighted_point(p13,1)
#wp14 = Weighted_point(p14,1)
#wp15 = Weighted_point(p15,1)
wp16 = Weighted_point(p2,1)
wp17 = Weighted_point(p3,20)
wp19 = Weighted_point(p9,0.5)
wp29 = Weighted_point(p9,22)
wp22 = Weighted_point(p12,300)

lw =[]
lw.append(wp0)
lw.append(wp1) 
lw.append(wp2) 
lw.append(wp3)
#  
#    
vw = []
vw.append(wp0)
vw.append(wp1) 
vw.append(wp2) 
vw.append(wp3)

# 
#   /*****************************/
#   /***** CONSTRUCTORS (1) ******/
print"    constructors(1)" 

T1 = Regular_triangulation_2()
assert( T1.dimension() == -1 ) 
assert( T1.number_of_vertices() == 0 )


T3 = Regular_triangulation_2(T1)
T4 = T1


print"    insertions 0-dim" 

T0_0 = Regular_triangulation_2()
assert( T0_0.dimension() == -1 )
assert( T0_0.number_of_vertices() == 0 )
assert( T0_0.is_valid(verbose) )

T0_1 = Regular_triangulation_2()
v0_1_0 = T0_1.insert(wp0)
assert( v0_1_0 != None )
assert( T0_1.dimension() == 0 )
assert( T0_1.number_of_vertices() == 1 )
assert( T0_1.is_valid(verbose) )

T0_2 = Regular_triangulation_2() 
T0_2.insert_first(wp0)
assert( T0_2.dimension() == 0 )
assert( T0_2.number_of_vertices() == 1 )
assert( T0_2.is_valid(verbose) )


#   /******** 1-dimensional triangulations ******/
#   # T1_n denotes a 1-dimensional triangulation with n vertices
#   # when there are several, we use T1_n_p
print"    insertions 1-dim" 

T1_5 = Regular_triangulation_2()
v1_5_1 = T1_5.insert(wp1) 
T1_5.is_valid(verbose)
v1_5_2 = T1_5.insert(wp2) 
T1_5.is_valid(verbose)
v1_5_3 = T1_5.insert(wp3)  #hidden vertex
T1_5.is_valid(verbose)
v1_5_9 = T1_5.insert(wp9) 
T1_5.is_valid(verbose)
v1_5_8 = T1_5.insert(wp8) #hide wp9
T1_5.is_valid(verbose) 

assert( T1_5.dimension() == 1 )
assert( T1_5.number_of_vertices() == 3)
assert( T1_5.is_valid(verbose) )
v1_5_16 =  T1_5.insert(wp16); T1_5.is_valid(verbose)
v1_5_17 =  T1_5.insert(wp17); T1_5.is_valid(verbose)
#   
#   # test insert_second()
T1_6 = T0_2 
T1_6.insert_second( wp3)
assert( T1_6.dimension() == 1 )
assert( T1_6.number_of_vertices() == 2 )
assert( T1_6.is_valid(verbose) ) 


T2_3 = Regular_triangulation_2()
v2_3_1 = T2_3.insert(wp1) 
T2_3.is_valid(verbose)
v2_3_3 = T2_3.insert(wp3) 
T2_3.is_valid(verbose) 
v2_3_9 = T2_3.insert(wp9) 
T2_3.is_valid(verbose)
v2_3_2 = T2_3.insert(wp8) 
T2_3.is_valid(verbose)
v2_3_8 = T2_3.insert(wp2) 
T2_3.is_valid(verbose)
assert( T2_3.dimension() == 1 ) 
T2_3.is_valid(verbose)

# /******** 2-dimensional triangulations ******/ 
print"    insertions 2-dim" 

v2_3_4 = T2_3.insert(wp4)
assert( T2_3.dimension() == 2 ) 
T2_3.is_valid(verbose)
v2_3_6 = T2_3.insert(wp6, T2_3.faces.next())
T2_3.is_valid(verbose)
v2_3_0 = T2_3.insert(wp0, T2_3.faces.next())
T2_3.is_valid(verbose)
v2_3_5 = T2_3.insert(wp5)
T2_3.is_valid(verbose)
v2_3_7 = T2_3.insert(wp7)
T2_3.is_valid(verbose)
l=[]
loc = T2_3.locate(wp10,l);lt = l[0];li=l[1]
v2_3_10 = T2_3.insert(wp10, lt, loc,li)
assert( T2_3.dimension() == 2 )
assert( T2_3.is_valid(verbose) )


# test list iterator insert
T2_5 = Regular_triangulation_2()
assert( T2_5.insert(lw))
assert( T2_5.dimension() == 2 )
assert( T2_5.number_of_vertices() == 3)
assert( T2_5.is_valid(verbose) )

# test list iterator insert
T2_6 = Regular_triangulation_2()
assert( T2_6.insert(vw))
assert( T2_6.dimension() == 2 )
assert( T2_6.number_of_vertices() == 3)
assert( T2_6.is_valid(verbose) )
  
# test grid insert and make sure append exists
T2_7 = Regular_triangulation_2()

for m in range(3):
	for p in range(3):
		T2_7.insert( Weighted_point(Point_2(m*px+p*qx, m*py+p*qy), 1) )
assert( T2_7.is_valid(verbose) )


print"    constructors (2)" 

# test copy_constructor with non-empty 0-triangulation
T0_1_1 = T0_1
assert( T0_1_1.dimension() == 0 )
assert( T0_1_1.number_of_vertices() == 1 )
assert( T0_1_1.is_valid(verbose) )

# test assignement

T0_1_2 = T0_1
assert( T0_1_2.dimension() == 0 )
assert( T0_1_2.number_of_vertices() == 1 )
assert( T0_1_2.is_valid(verbose) )


# test copy_constructor with non-empty 2-triangulation
T2_3_1 = Regular_triangulation_2( T2_3 )
assert( T2_3_1.dimension() == T2_3.dimension())
assert( T2_3_1.number_of_vertices() == T2_3.number_of_vertices())
assert( T2_3_1.number_of_hidden_vertices()== 
	T2_3.number_of_hidden_vertices() ) 
assert( T2_3_1.is_valid(verbose) )

#  
#  /*********************************************/
#   /****** FINITE/INFINITE VERTICES/FACES *******/
# 
print"    finite/infinite vertices/faces" 
l=[]
for v in T2_3_1.vertices:
	l.append(v)

assert(len(l) == T2_3_1.number_of_vertices() )

l =[]
for f in T2_3_1.faces:
	l.append(f)
assert(len(l) == T2_3_1.number_of_faces() )

print"    point locations 1-dim" 
T1_3_2 = Regular_triangulation_2()
T1_3_2.insert(wp1)
T1_3_2.insert(wp2)
T1_3_2.insert(wp9) 
T1_3_2.is_valid(verbose)
l=[]
loc = T1_3_2.locate(p1,l) ;lt =l[0];li=l[1];assert( lt == Regular_triangulation_2.Locate_type.VERTEX )
assert( loc.vertex(li).point() == p1 )
l=[]
loc = T1_3_2.locate(p2,l); lt =l[0];li=l[1];assert( lt == Regular_triangulation_2.Locate_type.VERTEX )
assert(loc.vertex(li).point() ==  p2 )
l=[]
loc = T1_3_2.locate(p9,l); lt =l[0];li=l[1];assert( lt == Regular_triangulation_2.Locate_type.VERTEX )
assert( loc.vertex(li).point() == p9 )
l=[]
loc = T1_3_2.locate(p3,l); lt =l[0];li=l[1];assert( lt == Regular_triangulation_2.Locate_type.EDGE )
assert( loc.vertex(loc.ccw(li)).point().point() == p1 and loc.vertex(loc.cw(li)).point().point() == p2)
l=[]
loc = T1_3_2.locate(p8,l); lt =l[0];li=l[1];assert( lt == Regular_triangulation_2.Locate_type.OUTSIDE_CONVEX_HULL )
l=[]
loc = T1_3_2.locate(p7,l); lt =l[0];li=l[1];assert( lt == Regular_triangulation_2.Locate_type.OUTSIDE_AFFINE_HULL )
l=[]
loc = T1_3_2.locate(p5,l); lt =l[0];li=l[1];assert( lt == Regular_triangulation_2.Locate_type.OUTSIDE_AFFINE_HULL )
l=[]
loc = T1_3_2.locate(p4,l); lt =l[0];li=l[1];assert( lt == Regular_triangulation_2.Locate_type.OUTSIDE_AFFINE_HULL )
l=[]
loc = T1_3_2.locate(p6,l); lt =l[0];li=l[1];assert( lt == Regular_triangulation_2.Locate_type.OUTSIDE_AFFINE_HULL)

#   /***************************/
#   /******* Circulators *******/
print"    circulators" 
# Line_face_circulator
print"    line face circulator  " 
print len(T2_3.line_walk(p0,p2))
print len(T2_3.line_walk(wp0,wp2))	
cir_faces = T2_3.incident_faces(v2_3_10)
l=[]
f1 = cir_faces.next()
l.append(f1)
for f in cir_faces:
	if f == f1:
		break
	l.append(f)
print len(l)

for v in T2_3.vertices:
	print v.point()


# /*****************************/
# /******** Miscellaneaous *****/
print"    misc." 
assert( T0_0.ccw(0) == 1 )
assert( T0_0.ccw(1) == 2 )
assert( T0_0.ccw(2) == 0 )
assert( T0_0.cw(0) == 2 )
assert( T0_0.cw(1) == 0 )
assert( T0_0.cw(2) == 1 )


# /***************************/
# /***** get_conflicts ******/
# 
# 
# /***** Duality ******/
print"    duality"
for e in T2_3.edges:
	s =  T2_3.dual(e)
	if s.__class__ == Segment_2:
		print "Segment_2"
	if s.__class__ == Ray_2:
		print "Ray_2"
	else:
		print "Line_2"

