#!/usr/bin/python
from sys import *
path.append("../../cgal_package")

from CGAL.Triangulations_2 import *
from CGAL.Kernel import *
from random import *


def Point_2_str(self):
    return "Point_2"+str((self.x(), self.y()))
# now we turn it into a member function
Point_2.__str__ = Point_2_str

def test_triangulation_2():	
	#======================================================= 
	print "		======================================================"
	print "				testing Triangulation_2"
	print "		======================================================\n"

	
	p0 = Point_2(5,6,1);
	p1 = Point_2(1,9,1);
	p2 = Point_2(6,14,1);
	p3 = Point_2(4,12,1);
	p4 = Point_2(3,29,1);
	p5 = Point_2(6,7,1);
	p6 = Point_2(6,39,1);
	p7 = Point_2(8,9,1);
	p8 = Point_2(10,18,1);
	p9 = Point_2(75625,155625,10000); # intersection of p2,p8 and p6,p7
	p10 = Point_2(10,50,2);
	p11 = Point_2(6,15,2); # midpoint p1,p0
	p12 = Point_2(6,16,2); # slightly above, in face
	p13 = Point_2(10,11,1);
	p14 = Point_2(10,40,1);
	p15 = Point_2(60,-10,1);
	
	px, py = 1 , 1;
	qx, qy = -1 , 2;
	
	l = []; l.append(p0);
	l.append(p1); l.append(p2); l.append(p3);
	l.append(p4); l.append(p5); l.append(p6);
	l.append(p7); l.append(p8); l.append(p9);
	
	
	for p in l:
		print p
		
	v =[]
	v.append(p0);
	v.append(p1); v.append(p2); v.append(p3);
	v.append(p4); v.append(p5); v.append(p6);
	v.append(p7); v.append(p8); v.append(p9);
	
	#   /*****************************/
	#   /***** CONSTRUCTORS (1) ******/
	print "constructors(1)\n"
	
	T1 = Triangulation_2()
	assert( T1.dimension() == -1 ); 
	assert( T1.number_of_vertices() == 0 );
	
	T3 = Triangulation_2(T1)
	T4 = Triangulation_2()
	T4 = T1
	T3.swap(T1)
	
	# 
	#   /**************************/
	#   /******* INSERTIONS *******/
	
	# Tk denotes a k-dimensional triangulation
	# the handle returned when inserting pj into Tk_n is called vk_n_j
	# the asserts at the end of the insert() are to avoid compiler
	# warnings about unused variables
	# we use some of these variables for the remove (see the end)
	# so there is no need to put assert at the end of all of them
	
	# /******* 0-dimensional triangulations ******/
	print "insertions 0-dim\n" 
	
	T0_0 = Triangulation_2() ;
	assert( T0_0.dimension() == -1 );
	assert( T0_0.number_of_vertices() == 0 );
	assert( T0_0.number_of_faces() == 0);
	assert( T0_0.is_valid() );
	
	T0_1 = Triangulation_2(); 
	v0_1_0 = T0_1.insert(p0); assert( v0_1_0 != None );
	assert( T0_1.dimension() == 0 );
	assert( T0_1.number_of_vertices() == 1 );
	assert( T0_1.number_of_faces() == 0);
	assert( T0_1.is_valid() );
	
	# test insert_first()
	T0_2 = Triangulation_2() ; 
	v0_2_0 =   T0_2.insert_first(p0);
	assert( v0_2_0 != None );
	assert( T0_2.dimension() == 0 );
	assert( T0_2.number_of_vertices() == 1 );
	assert( T0_2.number_of_faces() == 0);
	assert( T0_2.is_valid() );
	
	#   /******** 1-dimensional triangulations ******/
	#   # T1_n denotes a 1-dimensional triangulation with n vertices
	#   # when there are several, we use T1_n_p
	print "insertions 1-dim" 
	
	T1_2 = Triangulation_2() ;
	v1_2_1 = T1_2.insert(p1);
	v1_2_2 = T1_2.insert(p2);
	assert( T1_2.dimension() == 1 );
	assert( T1_2.number_of_vertices() == 2 );
	assert( T1_2.number_of_faces() == 0 );
	assert( T1_2.is_valid() );
	
	# p1,p3,p2  [endpoints first]
	T1_3_0 = Triangulation_2() ;
	v1_3_0_1 = T1_3_0.insert(p1); assert( v1_3_0_1 != None );
	v1_3_0_3 = T1_3_0.insert(p3); assert( v1_3_0_3 != None );
	v1_3_0_2 = T1_3_0.insert(p2); assert( v1_3_0_2 != None );
	assert( T1_3_0.dimension() == 1 );
	assert( T1_3_0.number_of_vertices() == 3 );
	assert( T1_3_0.number_of_faces() == 0 );
	assert( T1_3_0.is_valid() );
	
	# p1,p2,p3  [middle point first]
	T1_3_1 = Triangulation_2() ;
	v1_3_1_1 = T1_3_1.insert(p1); assert( v1_3_1_1 != None );
	v1_3_1_3 = T1_3_1.insert(p2); assert( v1_3_1_3 != None );
	v1_3_1_2 = T1_3_1.insert(p3); assert( v1_3_1_2 != None );
	assert( T1_3_1.dimension() == 1 );
	assert( T1_3_1.number_of_vertices() == 3 );
	assert( T1_3_1.number_of_faces() == 0 );
	assert( T1_3_1.is_valid() );
	
	T1_5 = Triangulation_2() ;
	v1_5_1 = T1_5.insert(p1);
	v1_5_2 = T1_5.insert(p2);
	v1_5_3 = T1_5.insert(p3);
	v1_5_8 = T1_5.insert(p8);
	v1_5_9 = T1_5.insert(p9);
	
	assert( T1_5.dimension() == 1 );
	assert( T1_5.number_of_vertices() == 5 );
	assert( T1_5.number_of_faces() == 0 );
	assert( T1_5.is_valid() );
	
	# test insert_second()
	T1_6 = Triangulation_2()
	T1_6 = T0_2 
	v1_6_2 = T1_6.insert_second(p3); assert( v1_6_2 != None );
	assert( T1_6.dimension() == 1 );
	assert( T1_6.number_of_vertices() == 2 );
	assert( T1_6.is_valid() ); 
	
	#   /******** 2-dimensional triangulations ******/ 
	print "insertions 2-dim" 
	
	T2_1 = Triangulation_2() ;
	v2_1_0 = T2_1.insert(p0);
	v2_1_1 = T2_1.insert(p1);
	v2_1_2 = T2_1.insert(p2);
	v2_1_3 = T2_1.insert(p3); # on the edge p1,p2, on the convex hull
	v2_1_4 = T2_1.insert(p4); # outside, with two visible collineaar edges
	v2_1_5 = T2_1.insert(p5); 
	v2_1_6 = T2_1.insert(p6);  # outside, collinear with p2,p5
	v2_1_7 = T2_1.insert(p7);  # outside with two visible collinear edges
										# but also collinear with and extending p0,p5 
	v2_1_8 = T2_1.insert(p8); 
	v2_1_9 = T2_1.insert(p9);    # inside, on the edge p6,p7
	v2_1_10 = T2_1.insert(p10);  # inside the face p2,p4,p6
	assert( T2_1.dimension() == 2 );
	assert( T2_1.number_of_vertices() == 11 );
	
	assert( T2_1.number_of_faces() == 2 * 12 - 4 - T2_1.infinite_vertex().degree() );
	
	assert( T2_1.number_of_faces() == 2 * 12 - 4 - T2_1.degree(T2_1.infinite_vertex()) );
	
	# test is_valid for 2-triangulations
	assert( T2_1.is_valid() );
	
	#   # we now test the other insert functions
	#   # more vicious, we insert all the points on a single line first
	T2_3 = Triangulation_2() ;
	v2_3_1 = T2_3.insert(p1);
	v2_3_2 = T2_3.insert(p2);
	v2_3_3 = T2_3.insert(p3);
	v2_3_8 = T2_3.insert(p8);
	v2_3_9 = T2_3.insert(p9);
	assert( T2_3.dimension() == 1 );
	v2_3_4 = T2_3.insert(p4);
	assert( T2_3.dimension() == 2 );
	face_iter = T2_3.faces
	v2_3_6 = T2_3.insert(p6, face_iter.next());
	v2_3_0 = T2_3.insert(p0, face_iter.next());
	v2_3_5 = T2_3.insert(p5);
	v2_3_7 = T2_3.insert(p7);
	liste=[]
	loc = T2_3.locate(p10,liste); 
	v2_3_10 = T2_3.insert(p10, liste[0], loc, liste[1]);
	lt = liste[0]
	assert( lt == Triangulation_2.Locate_type.FACE );
	assert( T2_3.dimension() == 2 );
	assert( T2_3.number_of_vertices() == 11 );
	assert( T2_3.is_valid() );
	
	# make sure inserting on a previous point does not insert it again
	assert( T2_3.insert(p10) == v2_3_10 );
	assert( T2_3.number_of_vertices() == 11 );
	
	# make sure append exists and does the same thing as insert
	# assert( T2_3.append(p10) == v2_3_10 );
	assert( T2_3.number_of_vertices() == 11 );
	
	# test inserting of list points
	liste = []
	for p in T2_1.points:
		liste.append(p)
	
	T2_4 = Triangulation_2() ; T2_4.insert( liste )
	assert( T2_4.dimension() == 2 );
	assert( T2_4.number_of_vertices() == 11 );
	assert( T2_4.is_valid() );
	
	#test grid insert
	T2_7 = Triangulation_2() ;
	for m in range(3):
		for p in range(3):
			T2_7.insert( Point_2(m*px+p*qx, m*py+p*qy, 1) )
	assert( T2_7.is_valid() );
	
	# test flip
	print "test flip " 
	
	T2_8 = Triangulation_2() ;
	T2_8.insert(Point_2(0,0,1));
	T2_8.insert(Point_2(1,0,1));
	T2_8.insert(Point_2(1,1,1));
	T2_8.insert(Point_2(0,1,1));
	liste=[]
	ff = T2_8.locate(Point_2(1,1,2),liste);
	lt,li = liste[0],liste[1]
	assert(lt == Triangulation_2.Locate_type.EDGE)
	assert(T2_8.is_infinite(ff) == False)
	f2 = ff.neighbor(li)
	assert(T2_8.is_infinite(f2) == False)
	T2_8.flip(ff,0)
	assert( T2_8.is_valid() )
	# /****************************/
	# /***** CONSTRUCTORS (2) *****/
	print "constructors (2)" 
	
	# test copy_constructor with non-empty 0-triangulation
	T0_1_1 = Triangulation_2( T0_1 );
	assert( T0_1_1.dimension() == 0 );
	assert( T0_1_1.number_of_vertices() == 1 );
	assert( T0_1_1.is_valid() );
	
	# test copy_constructor with non-empty 1-triangulation
	T1_5_1 = Triangulation_2( T1_5 );
	assert( T1_5_1.dimension() == 1 );
	assert( T1_5_1.number_of_vertices() == 5 );
	assert( T1_5_1.is_valid() );
	
	# Test assignment operator
	T1_5_2 = T1_5;
	assert( T1_5_2.dimension() == 1 );
	assert( T1_5_2.number_of_vertices() == 5 );
	assert( T1_5_2.is_valid() );
	
	# test copy_constructor with non-empty 2-triangulation
	T2_8_1 = Triangulation_2(T2_8);
	assert( T2_8_1.is_valid());
	T2_1_1 = Triangulation_2( T2_1 );
	assert( T2_1_1.dimension() == 2 );
	assert( T2_1_1.number_of_vertices() == 11 );
	assert( T2_1_1.is_valid() );
	
	# test assignment operator
	T2_1_4 = T2_1;
	assert( T2_1_4.dimension() == 2 );
	assert( T2_1_4.number_of_vertices() == 11 );
	assert( T2_1_4.is_valid() );
	
	# 
	#   /*********************************************/
	#   /****** FINITE/INFINITE VERTICES/FACES *******/
	# 
	print "finite/infinite vertices/faces" 
	if ( T2_3.infinite_face() != None ):
		assert( T2_3.is_infinite(T2_3.infinite_face()) );
	
	# test infinite_vertex() and is_infinite(Vertex_handle)
	assert( T2_3.is_infinite(T2_3.infinite_vertex()) );
	
	# test finite_vertex()
	# missing in the documentation is the precondition that there
	# must be at least one vertex
	if (T2_3.number_of_vertices() != 0):
		assert( T2_3.is_infinite(T2_3.finite_vertex()) == False );
	
	# test is_infinite(Edge)
	# an infinite face always has two infinite edges
	if ( T2_3.infinite_face() != None ):
		index = T2_3.infinite_face().index(T2_3.infinite_vertex());
		assert( T2_3.is_infinite( Edge(T2_3.infinite_face(),(index+1)%3)) );
		assert( T2_3.is_infinite( Edge(T2_3.infinite_face(),(index+2)%3)) );
	
	# test is_infinite(Edge_iterator)
	# . for edge iterator
	for aei in T2_3.all_edges:	
		if (T2_3.is_infinite(aei)):
			assert ( T2_3.is_infinite(aei.face().vertex(T2_3.ccw(aei.vertex()))) or T2_3.is_infinite( aei.face().vertex( T2_3.cw( aei.vertex() ) ) ));
	
	print "is_edge, is_face, includes_edge" 
	assert(  T1_5.is_edge(v1_5_1,v1_5_3));
	assert( T1_5.is_edge(v1_5_1,v1_5_2) == False);
	# assert(  T1_5.is_edge(v1_5_1,v1_5_3,f,li));
	# assert( T1_5.is_edge(v1_5_1,v1_5_2,f,li) == False);
	assert(  T2_1.is_edge(v2_1_1,v2_1_3));
	assert(  T2_1.is_edge(v2_1_1,v2_1_2) == False);
	# assert(  T2_1.is_edge(v2_1_1,v2_1_3,f,li));
	# assert( T2_1.is_edge(v2_1_1,v2_1_2,f,li) == False);
	f = T2_1.faces.next() #T2_1.finite_faces_begin();
	v0 = f.vertex(0);
	v1 = f.vertex(1);
	v2 = f.vertex(2);
	v3 = T2_1.mirror_vertex(f,0);
	assert(T2_1.is_face(v0,v1,v2));
	assert(T2_1.is_face(v0,v2,v1));
	assert(T2_1.is_face(v0,v3,v1)== False);
	
	#   /*************************************/
	#   /******** POINT LOCATIONS ************/
	# 
	#   # Locate_type lt; # see above
	#   
	# Check point location in 0-dimensional triangulations
	# No need because of precondition (at least two vertices)
	
	# Check point location in 1-dimensional triangulations
	print "point locations 1-dim" 
	T1_3_2 = Triangulation_2() ;
	T1_3_2.insert(p1);
	T1_3_2.insert(p2);
	T1_3_2.insert(p9);
	f = T1_3_2.locate(p1,liste); lt,li = liste[0],liste[1]
	assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T1_3_2.xy_equal(f.vertex(li).point(), p1) );
	f = T1_3_2.locate(p2,liste); lt,li = liste[0],liste[1]
	assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T1_3_2.xy_equal(f.vertex(li).point(), p2) );
	f = T1_3_2.locate(p9,liste);lt,li = liste[0],liste[1]
	assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T1_3_2.xy_equal(f.vertex(li).point(), p9) );
	f = T1_3_2.locate(p3,liste);lt,li = liste[0],liste[1]
	assert( lt == Triangulation_2.Locate_type.EDGE );
	assert( (T1_3_2.xy_equal(f.vertex(f.ccw(li)).point(), p1)
		and T1_3_2.xy_equal(f.vertex(f.cw(li)).point(), p2))
		or (T1_3_2.xy_equal(f.vertex(f.ccw(li)).point(), p2)
		and T1_3_2.xy_equal(f.vertex(f.cw(li)).point(), p1)));
	
	f = T1_3_2.locate(p8,liste);lt,li = liste[0],liste[1] 
	assert( lt == Triangulation_2.Locate_type.OUTSIDE_CONVEX_HULL );
	assert(T1_3_2.is_infinite(f.vertex(li)));
	
	f = T1_3_2.locate(p0,liste);lt,li = liste[0],liste[1] 
	assert( lt == Triangulation_2.Locate_type.OUTSIDE_AFFINE_HULL );
	f = T1_3_2.locate(p7,liste);lt,li = liste[0],liste[1] 
	assert( lt == Triangulation_2.Locate_type.OUTSIDE_AFFINE_HULL );
	f = T1_3_2.locate(p5,liste);lt,li = liste[0],liste[1] 
	assert( lt == Triangulation_2.Locate_type.OUTSIDE_AFFINE_HULL );
	f = T1_3_2.locate(p4,liste);lt,li = liste[0],liste[1] 
	assert( lt == Triangulation_2.Locate_type.OUTSIDE_AFFINE_HULL );
	f = T1_3_2.locate(p6,liste);lt,li = liste[0],liste[1] 
	assert( lt == Triangulation_2.Locate_type.OUTSIDE_AFFINE_HULL );
	
	#   # Check point location in 2-dimensional triangulations
	print "point locations 2-dim" 
	l=[]
	f = T2_1.locate(p0,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p0) );

	f = T2_1.locate(p1,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p1) );

	f = T2_1.locate(p2,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p2) );

	f = T2_1.locate(p3,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p3) );

	f = T2_1.locate(p4,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p4) );

	f = T2_1.locate(p5,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p5) );

	f = T2_1.locate(p6,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p6) );

	f = T2_1.locate(p7,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p7) );

	f = T2_1.locate(p8,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p8) );

	f = T2_1.locate(p9,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p9) );

	f = T2_1.locate(p10,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
	assert( T2_1.xy_equal(f.vertex(li).point(), p10) );

	f = T2_1.locate(p11,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.EDGE );
	
	assert( (T2_1.xy_equal(f.vertex(f.ccw(li)).point(), p1)
		and T2_1.xy_equal(f.vertex(f.cw(li)).point(), p0))
		or (T2_1.xy_equal(f.vertex(f.ccw(li)).point(), p0)
		and T2_1.xy_equal(f.vertex(f.cw(li)).point(), p1)));

	f = T2_1.locate(p12,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.FACE );	
	assert( T2_1.oriented_side(f,p12) == Oriented_side.ON_POSITIVE_SIDE );

	f = T2_1.locate(p13,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.OUTSIDE_CONVEX_HULL );	
	
	print "test grid locate"
	for m in range(1):
		for p in range(1):
			q = Point_2(m*px+p*qx, m*py+p*qy, 1);
			l =[]
			f = T2_7.locate(q,l);lt,li = l[0],l[1]; assert( lt == Triangulation_2.Locate_type.VERTEX );
			assert( T2_7.xy_equal(f.vertex(li).point(), q) );
		
	for m in range(1):
		for p in range(1):	
			q= Point_2(2*m*px+(2*p+1)*qx, 2*m*py+(2*p+1)*qy, 2);
			r= Point_2(m*px+p*qx, m*py+p*qy, 1);
			s= Point_2(m*px+(p+1)*qx, m*py+(p+1)*qy, 1);
			l =[];f = T2_7.locate(q,l);lt,li = l[0],l[1]; 
			assert( lt == Triangulation_2.Locate_type.EDGE );
			assert( (T2_7.xy_equal(f.vertex(f.ccw(li)).point(), r)
				and T2_7.xy_equal(f.vertex(f.cw(li)).point(), s))
				or (T2_7.xy_equal(f.vertex(f.ccw(li)).point(), s)
				and T2_7.xy_equal(f.vertex(f.cw(li)).point(), r)));
		
			
	for m in range(1):
		for p in range(1):
			q= Point_2((50*m+1)*px+(50*p+1)*qx, (50*m+1)*py+(50*p+1)*qy, 50);
			l =[]; f = T2_7.locate(q,l);lt,li = l[0],l[1];
			assert( lt == Triangulation_2.Locate_type.FACE );
			assert( T2_7.oriented_side(f,q) == Oriented_side.ON_POSITIVE_SIDE );
	
	# the two point are vertices of the triangulation.
	TT = Triangulation_2() ;
	TT.insert(Point_2(0,0)); TT.insert(Point_2(1,0));TT.insert(Point_2(1,1));
	TT.insert(Point_2(0,1));
	assert(TT.dimension()==2);
	assert(TT.is_valid());
	assert(TT.number_of_vertices()==4);
	l =[];f = TT.locate(Point_2(0,0),l);lt,li = l[0],l[1]
	assert(lt == Triangulation_2.Locate_type.VERTEX);
	fcc = TT.incident_faces(f.vertex(li),f);
	while( TT.is_infinite(fcc.next())):
		fcc.next();
	fh2 = fcc.next();fh1 = fh2
	fc = TT.line_walk(Point_2(0,0),Point_2(1,1),fh1);
	fc2 = TT.line_walk(Point_2(0,0),Point_2(1,1),fh2);
	
	#   /*****************************/
	#   /******** Miscellaneaous *****/
	print "Miscellaneaous" 
	assert( T0_0.ccw(0) == 1 );
	assert( T0_0.ccw(1) == 2 );
	assert( T0_0.ccw(2) == 0 );
	assert( T0_0.cw(0) == 2 );
	assert( T0_0.cw(1) == 0 );
	assert( T0_0.cw(2) == 1 );
	
	#   /**********************/
	#   /***** REMOVALS *******/ 
	print "removals" 
	
	# test remove_first()
	T0_1.remove_first(T0_1.finite_vertex());
	assert( T0_1.number_of_vertices() == 0 );
	
	# test remove_second()
	T1_6.remove_second(T1_6.finite_vertex());
	assert( T1_6.is_valid());
	assert( T1_6.number_of_vertices() == 1 );
	
	# remove from 1-dimensional triangulations
	T1_2.remove(v1_2_1);
	assert( T1_2.is_valid());
	T1_2.remove(v1_2_2);
	assert( T1_2.number_of_vertices() == 0 );
	
	T1_5.remove(v1_5_1);
	assert( T1_5.is_valid());
	T1_5.remove(v1_5_2);
	T1_5.remove(v1_5_3);
	T1_5.remove(v1_5_8);
	T1_5.remove(v1_5_9);
	assert( T1_5.number_of_vertices() == 0 );
	
	# remove from 2-dimensional triangulations
	T2_1.remove(v2_1_10); assert( T2_1.is_valid());
	T2_1.remove(v2_1_9);
	T2_1.remove(v2_1_8);
	T2_1.remove(v2_1_7);
	T2_1.remove(v2_1_6);
	T2_1.remove(v2_1_5);
	T2_1.remove(v2_1_4);
	T2_1.remove(v2_1_3); assert(T2_1.is_valid());
	T2_1.remove(v2_1_0);
	assert(T2_1.is_valid());
	T2_1.remove(v2_1_2); assert(T2_1.is_valid());
	T2_1.remove(v2_1_1); assert(T2_1.is_valid());
	assert( T2_1.number_of_vertices() == 0 );
	
	T2_3.remove(v2_3_0); assert(T2_3.is_valid());
	T2_3.remove(v2_3_1); assert(T2_3.is_valid());
	T2_3.remove(v2_3_9); assert(T2_3.is_valid());
	T2_3.remove(v2_3_8); assert(T2_3.is_valid()); 
	T2_3.remove(v2_3_5); assert(T2_3.is_valid()); 
	T2_3.remove(v2_3_3); assert(T2_3.is_valid());
	T2_3.remove(v2_3_4); assert(T2_3.is_valid());
	T2_3.remove(v2_3_2); assert(T2_3.is_valid());
	T2_3.remove(v2_3_6); assert(T2_3.is_valid());
	T2_3.remove(v2_3_7); assert(T2_3.is_valid()); 
	T2_3.remove(v2_3_10); assert(T2_3.is_valid());
	assert( T2_3.number_of_vertices() == 0 );
	# 
	
	for i in range(T2_4.number_of_vertices()):
		T2_4.remove(T2_4.finite_vertex());
	assert( T2_4.number_of_vertices() == 0 );
	
	T0_0.clear();
	assert( T0_0.number_of_vertices() == 0 );
if __name__=='__main__':
	test_triangulation_2()
